<p align="center">
<img src="https://raw.githubusercontent.com/AcmeSoftwareLLC/clean-framework-intellij/main/src/main/resources/META-INF/pluginIcon.svg" height="100" alt="Clean Framework" />
</p>

<p align="center">
<strong>Clean Framework</strong>
</p>

[![Coverage](https://codecov.io/gh/AcmeSoftwareLLC/clean_framework/branch/main/graph/badge.svg)](https://codecov.io/gh/AcmeSoftwareLLC/clean_framework)

Flutter implementation of Clean Architecture, inspired on the guidelines created by Uncle Bob.

Go to [the documentation](https://cleanframework.acmesoftware.com).

### Examples

Example Repository: [Link](https://github.com/AcmeSoftwareLLC/clean_framework_examples)

#### [example_rest](https://github.com/AcmeSoftwareLLC/clean_framework_examples/tree/main/example_rest): Pokémon App w/RESTful Backend

Simple Pokémon browser app, showcasing how a simple app with a clean UI and a RESTful backend (PokéAPI REST API v2) might be written using `clean_framework.`

Example Web Demo: https://cleanframeworkdemo.acmesoftware.com

#### [example_graphql](https://github.com/AcmeSoftwareLLC/clean_framework_examples/tree/main/example_graphql): Pokémon App w/GraphQL Backend

Simple Pokémon browser app, this time utilizing a GraphQL backend (PokéAPI GraphQL API v1 beta). This app showcases how the `clean_framework_graphql` package can be used alongside `clean_framework` to easily interact with a GraphQL API.

#### [graphql_example](https://github.com/AcmeSoftwareLLC/clean_framework_examples/tree/main/graphql_example): Scenario Example - Using `clean_framework_graphql`

Sample app with a bare-bones UI that illustrates the usage of the `clean_framework_graphql` package alongside `clean_framework` in interacting with a GraphQL API.

#### [theme_example](https://github.com/AcmeSoftwareLLC/clean_framework_examples/tree/main/theme_example): Scenario Example - Updating Theme

Sample app with a bare-bones UI that showcases how one might reach beyond the confines of a Clean Framework feature to update a global app theme, while still adhering to the principles of Clean Architecture.

### Tools

[Clean Framework IntelliJ Plugin](https://plugins.jetbrains.com/plugin/21072-clean-framework)
